Index: COPYING
===================================================================
--- COPYING	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ COPYING	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,11 +1,11 @@
-                    GNU GENERAL PUBLIC LICENSE
-                       Version 2, June 1991
-
- Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
- 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  Everyone is permitted to copy and distribute verbatim copies
  of this license document, but changing it is not allowed.
 
-                            Preamble
+			    Preamble
 
   The licenses for most software are designed to take away your
@@ -16,5 +16,5 @@
 Foundation's software and to any other program whose authors commit to
 using it.  (Some other Free Software Foundation software is covered by
-the GNU Lesser General Public License instead.)  You can apply it to
+the GNU Library General Public License instead.)  You can apply it to
 your programs, too.
 
@@ -57,5 +57,6 @@
 modification follow.
 
-                    GNU GENERAL PUBLIC LICENSE
+
+		    GNU GENERAL PUBLIC LICENSE
    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 
@@ -112,4 +113,5 @@
     the Program is not required to print an announcement.)
 
+
 These requirements apply to the modified work as a whole.  If
 identifiable sections of that work are not derived from the Program,
@@ -169,4 +171,5 @@
 distribution of the source code, even though third parties are not
 compelled to copy the source along with the object code.
+
 
   4. You may not copy, modify, sublicense, or distribute the Program
@@ -227,4 +230,5 @@
 be a consequence of the rest of this License.
 
+
   8. If the distribution and/or use of the Program is restricted in
 certain countries either by patents or by copyrighted interfaces, the
@@ -256,5 +260,5 @@
 of promoting the sharing and reuse of software generally.
 
-                            NO WARRANTY
+			    NO WARRANTY
 
   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
@@ -278,7 +282,8 @@
 POSSIBILITY OF SUCH DAMAGES.
 
-                     END OF TERMS AND CONDITIONS
-
-            How to Apply These Terms to Your New Programs
+		     END OF TERMS AND CONDITIONS
+
+
+	    How to Apply These Terms to Your New Programs
 
   If you develop a new program, and you want it to be of the greatest
@@ -304,7 +309,8 @@
     GNU General Public License for more details.
 
-    You should have received a copy of the GNU General Public License along
-    with this program; if not, write to the Free Software Foundation, Inc.,
-    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
 
 Also add information on how to contact you by electronic and paper mail.
@@ -313,5 +319,5 @@
 when it starts in an interactive mode:
 
-    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision version 69, Copyright (C) year  name of author
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
     This is free software, and you are welcome to redistribute it
@@ -336,4 +342,4 @@
 proprietary programs.  If your program is a subroutine library, you may
 consider it more useful to permit linking proprietary applications with the
-library.  If this is what you want to do, use the GNU Lesser General
+library.  If this is what you want to do, use the GNU Library General
 Public License instead of this License.
Index: Makefile
===================================================================
--- Makefile	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ Makefile	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -10,45 +10,24 @@
 
 # Program variables
-objects = bitlbee.o dcc.o help.o ipc.o irc.o irc_im.o irc_cap.o irc_channel.o irc_commands.o irc_send.o irc_user.o irc_util.o nick.o $(OTR_BI) query.o root_commands.o set.o storage.o $(STORAGE_OBJS) auth.o $(AUTH_OBJS) unix.o conf.o log.o
-allheaders = $(wildcard $(_SRCDIR_)*.h $(_SRCDIR_)lib/*.h $(_SRCDIR_)protocols/*.h)
-ifeq ($(EXTERNAL_JSON_PARSER),1)
-headers = $(filter-out $(_SRCDIR_)lib/json.h,$(allheaders))
-else
-headers = $(allheaders)
-endif
-subdirs = lib protocols
-
-OUTFILE = bitlbee
+objects = account.o bitlbee.o commands.o conf.o crypting.o help.o ini.o irc.o log.o nick.o query.o set.o unix.o url.o user.o debug.o
+subdirs = protocols
 
 # Expansion of variables
 subdirobjs = $(foreach dir,$(subdirs),$(dir)/$(dir).o)
+CFLAGS += -Wall
 
-all: $(OUTFILE) $(OTR_PI) doc systemd
+all: $(OUTFILE)
 
-doc:
-ifdef DOC
-	$(MAKE) -C doc
-endif
-
-uninstall: uninstall-bin uninstall-doc 
+uninstall: uninstall-bin uninstall-doc
 	@echo -e '\nmake uninstall does not remove files in '$(DESTDIR)$(ETCDIR)', you can use make uninstall-etc to do that.\n'
 
-install: install-bin install-doc install-plugins
-	@echo
-	@echo Installed successfully
-	@echo
-ifndef SYSTEMDSYSTEMUNITDIR
+install: install-bin install-doc
 	@if ! [ -d $(DESTDIR)$(CONFIG) ]; then echo -e '\nThe configuration directory $(DESTDIR)$(CONFIG) does not exist yet, don'\''t forget to create it!'; fi
-endif
 	@if ! [ -e $(DESTDIR)$(ETCDIR)/bitlbee.conf ]; then echo -e '\nNo files are installed in '$(DESTDIR)$(ETCDIR)' by make install. Run make install-etc to do that.'; fi
-ifdef SYSTEMDSYSTEMUNITDIR
-	@echo If you want to start BitlBee using systemd, try \"make install-systemd\".
-endif
-	@echo To be able to compile third party plugins, run \"make install-dev\"
 	@echo
 
-.PHONY:   install   install-bin   install-etc   install-doc install-plugins install-systemd install-dev \
-        uninstall uninstall-bin uninstall-etc uninstall-doc uninstall-etc \
-        all clean distclean tar $(subdirs) doc
+.PHONY:   install   install-bin   install-etc   install-doc \
+        uninstall uninstall-bin uninstall-etc uninstall-doc \
+        all clean distclean tar $(subdirs)
 
 Makefile.settings:
@@ -58,66 +37,27 @@
 
 clean: $(subdirs)
-	rm -f *.o $(OUTFILE) core utils/bitlbeed init/bitlbee*.service
-	$(MAKE) -C tests clean
+	rm -f *.o $(OUTFILE) core utils/bitlbeed encode decode
 
 distclean: clean $(subdirs)
-	rm -rf .depend
-	rm -f Makefile.settings config.h bitlbee.pc
-	find . -name 'DEADJOE' -o -name '*.orig' -o -name '*.rej' -o -name '*~' -exec rm -f {} \;
-	@# May still be present in dirs of disabled protocols.
-	-find . -name .depend -exec rm -rf {} \;
-	$(MAKE) -C tests distclean
-
-check: all
-	$(MAKE) -C tests
-
-gcov: check
-	gcov *.c
-
-lcov: check
-	lcov --directory . --capture --output-file bitlbee.info
-	genhtml -o coverage bitlbee.info
+	rm -f Makefile.settings config.h
+	find . -name 'DEADJOE' -o -name '*.orig' -o -name '*.rej' -o -name '*~' | xargs rm -f
 
 install-doc:
-ifdef DOC
 	$(MAKE) -C doc install
-endif
 
 uninstall-doc:
-ifdef DOC
 	$(MAKE) -C doc uninstall
-endif
 
 install-bin:
-	mkdir -p $(DESTDIR)$(SBINDIR)
-	$(INSTALL) -m 0755 $(OUTFILE) $(DESTDIR)$(SBINDIR)/$(OUTFILE)
-ifdef IMPLIB
-	# import library for cygwin
-	mkdir -p $(DESTDIR)$(LIBDIR)
-	$(INSTALL) -m 0644 $(IMPLIB) $(DESTDIR)$(LIBDIR)/$(IMPLIB)
-endif
+	mkdir -p $(DESTDIR)$(BINDIR)
+	install -m 0755 $(OUTFILE) $(DESTDIR)$(BINDIR)/$(OUTFILE)
 
 uninstall-bin:
-	rm -f $(DESTDIR)$(SBINDIR)/$(OUTFILE)
-ifdef IMPLIB
-	rm -f $(DESTDIR)$(LIBDIR)/$(IMPLIB)
-endif
-
-install-dev:
-	mkdir -p $(DESTDIR)$(INCLUDEDIR)
-	$(INSTALL) -m 0644 config.h $(DESTDIR)$(INCLUDEDIR)
-	for i in $(headers); do $(INSTALL) -m 0644 $$i $(DESTDIR)$(INCLUDEDIR); done
-	mkdir -p $(DESTDIR)$(PCDIR)
-	$(INSTALL) -m 0644 bitlbee.pc $(DESTDIR)$(PCDIR)
-
-uninstall-dev:
-	rm -f $(foreach hdr,$(headers),$(DESTDIR)$(INCLUDEDIR)/$(hdr))
-	-rmdir $(DESTDIR)$(INCLUDEDIR)
-	rm -f $(DESTDIR)$(PCDIR)/bitlbee.pc
+	rm -f $(DESTDIR)$(BINDIR)/$(OUTFILE)
 
 install-etc:
 	mkdir -p $(DESTDIR)$(ETCDIR)
-	$(INSTALL) -m 0644 $(_SRCDIR_)motd.txt $(DESTDIR)$(ETCDIR)/motd.txt
-	$(INSTALL) -m 0644 $(_SRCDIR_)bitlbee.conf $(DESTDIR)$(ETCDIR)/bitlbee.conf
+	install -m 0644 motd.txt $(DESTDIR)$(ETCDIR)/motd.txt
+	install -m 0644 bitlbee.conf $(DESTDIR)$(ETCDIR)/bitlbee.conf
 
 uninstall-etc:
@@ -126,51 +66,16 @@
 	-rmdir $(DESTDIR)$(ETCDIR)
 
-install-plugins: install-plugin-otr
-
-install-plugin-otr:
-ifdef OTR_PI
-	mkdir -p $(DESTDIR)$(PLUGINDIR)
-	$(INSTALL) -m 0755 otr.so $(DESTDIR)$(PLUGINDIR)
-endif
-
-systemd:
-ifdef SYSTEMDSYSTEMUNITDIR
-	mkdir -p init
-	sed 's|@sbindir@|$(SBINDIR)|' $(_SRCDIR_)init/bitlbee.service.in > init/bitlbee.service
-	sed 's|@sbindir@|$(SBINDIR)|' $(_SRCDIR_)init/bitlbee@.service.in > init/bitlbee@.service
-endif
-
-install-systemd: systemd
-ifdef SYSTEMDSYSTEMUNITDIR
-	mkdir -p $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
-	$(INSTALL) -m 0644 init/bitlbee.service $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
-	$(INSTALL) -m 0644 init/bitlbee@.service $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
-	$(INSTALL) -m 0644 $(_SRCDIR_)init/bitlbee.socket $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR)
-else
-	@echo SYSTEMDSYSTEMUNITDIR not set, not installing systemd unit files.
-endif
-
-ifdef SYSUSERSDIR
-	$(INSTALL) -Dm644 init/bitlbee.sysusers $(DESTDIR)/$(SYSUSERSDIR)/bitlbee.conf
-else
-	@echo SYSUSERSDIR not set, not install sysusers.d files
-endif
-
 tar:
 	fakeroot debian/rules clean || make distclean
 	x=$$(basename $$(pwd)); \
 	cd ..; \
-	tar czf $$x.tar.gz --exclude=debian --exclude=.git* --exclude=.depend $$x
+	tar czf $$x.tar.gz --exclude=debian $$x
 
 $(subdirs):
-	$(MAKE) -C $@ $(MAKECMDGOALS)
+	@$(MAKE) -C $@ $(MAKECMDGOALS)
 
-$(OTR_PI): %.so: $(_SRCDIR_)%.c
-	@echo '*' Building plugin $@
-	$(VERBOSE) $(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) $< -o $@ $(OTRFLAGS)
-
-$(objects): %.o: $(_SRCDIR_)%.c
+$(objects): %.o: %.c
 	@echo '*' Compiling $<
-	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	@$(CC) -c $(CFLAGS) $< -o $@
 
 $(objects): Makefile Makefile.settings config.h
@@ -178,25 +83,16 @@
 $(OUTFILE): $(objects) $(subdirs)
 	@echo '*' Linking $(OUTFILE)
-	$(VERBOSE) $(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LDFLAGS_BITLBEE) $(LDFLAGS) $(EFLAGS)
-ifneq ($(firstword $(STRIP)), \#)
+	@$(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LFLAGS) $(EFLAGS)
+ifndef DEBUG
 	@echo '*' Stripping $(OUTFILE)
-	$(VERBOSE) -$(STRIP) $(OUTFILE)
+	@-$(STRIP) $(OUTFILE)
 endif
+
+encode: crypting.c
+	$(CC) crypting.c protocols/md5.c $(CFLAGS) -o encode -DCRYPTING_MAIN $(CFLAGS) $(EFLAGS) $(LFLAGS)
+
+decode: encode
+	cp encode decode
 
 ctags: 
 	ctags `find . -name "*.c"` `find . -name "*.h"`
-
-# Using this as a bogus Make target to test if a GNU-compatible version of
-# make is available.
-helloworld:
-	@echo Hello World
-
-# Check if we can load the helpfile. (This fails if some article is >1KB.)
-# If print returns a NULL pointer, the file is unusable.
-testhelp: doc
-	gdb --eval-command='b main' --eval-command='r' \
-	    --eval-command='print help_init(&global->helpfile, "doc/user-guide/help.txt")' \
-	    $(OUTFILE) < /dev/null
-
--include .depend/*.d
-# DO NOT DELETE
Index: account.c
===================================================================
--- account.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ account.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,156 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Account management functions                                         */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "bitlbee.h"
+#include "account.h"
+
+account_t *account_add( irc_t *irc, int protocol, char *user, char *pass )
+{
+	account_t *a;
+	
+	if( irc->accounts )
+	{
+		for( a = irc->accounts; a->next; a = a->next );
+		a = a->next = g_new0 ( account_t, 1 );
+	}
+	else
+	{
+		irc->accounts = a = g_new0 ( account_t, 1 );
+	}
+	
+	a->protocol = protocol;
+	a->user = g_strdup( user );
+	a->pass = g_strdup( pass );
+	a->irc = irc;
+	
+	return( a );
+}
+
+account_t *account_get( irc_t *irc, char *id )
+{
+	account_t *a, *ret = NULL;
+	int nr;
+	
+	if( sscanf( id, "%d", &nr ) == 1 && nr < 1000 )
+	{
+		for( a = irc->accounts; a; a = a->next )
+			if( ( nr-- ) == 0 )
+				return( a );
+		
+		return( NULL );
+	}
+	
+	for( a = irc->accounts; a; a = a->next )
+	{
+		if( g_strcasecmp( id, proto_name[a->protocol] ) == 0 )
+		{
+			if( !ret )
+				ret = a;
+			else
+				return( NULL ); /* We don't want to match more than one... */
+		}
+		else if( strstr( a->user, id ) )
+		{
+			if( !ret )
+				ret = a;
+			else
+				return( NULL );
+		}
+	}
+	
+	return( ret );
+}
+
+void account_del( irc_t *irc, account_t *acc )
+{
+	account_t *a, *l = NULL;
+	
+	for( a = irc->accounts; a; a = (l=a)->next )
+		if( a == acc )
+		{
+			if( a->gc ) return; /* Caller should have checked, accounts still in use can't be deleted. */
+			
+			if( l )
+			{
+				l->next = a->next;
+			}
+			else
+			{
+				irc->accounts = a->next;
+			}
+			
+			g_free( a->user );
+			g_free( a->pass );
+			if( a->server ) g_free( a->server );
+			if( a->reconnect )	/* This prevents any reconnect still queued to happen */
+				cancel_auto_reconnect( a );
+			g_free( a );
+			
+			break;
+		}
+}
+
+void account_on( irc_t *irc, account_t *a )
+{
+	struct aim_user *u;
+	
+	if( a->gc )
+	{
+		/* Trying to enable an already-enabled account */
+		return;
+	}
+	
+	if( proto_prpl[a->protocol]->login == NULL )
+	{
+		irc_usermsg( irc, "Support for protocol %s is not included in this BitlBee", proto_name[a->protocol] );
+		return;
+	}
+	
+	cancel_auto_reconnect( a );
+	
+	u = g_new0 ( struct aim_user, 1 );
+	u->irc = irc;
+	u->protocol = a->protocol;
+	strncpy( u->username, a->user, sizeof( u->username ) - 1 );
+	strncpy( u->password, a->pass, sizeof( u->password ) - 1 );
+	if( a->server) strncpy( u->proto_opt[0], a->server, sizeof( u->proto_opt[0] ) - 1 );
+	
+	a->gc = (struct gaim_connection *) u; /* Bit hackish :-/ */
+	a->reconnect = 0;
+	
+	proto_prpl[a->protocol]->login( u );
+}
+
+void account_off( irc_t *irc, account_t *a )
+{
+	account_offline( a->gc );
+	a->gc = NULL;
+	if( a->reconnect )
+	{
+		/* Shouldn't happen */
+		cancel_auto_reconnect( a );
+	}
+}
Index: account.h
===================================================================
--- account.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ account.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,49 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Account management functions                                         */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef _ACCOUNT_H
+#define _ACCOUNT_H
+
+typedef struct account
+{
+	int protocol;
+	char *user;
+	char *pass;
+	char *server;
+	
+	int reconnect;
+	
+	struct irc *irc;
+	struct gaim_connection *gc;
+	struct account *next;
+} account_t;
+
+account_t *account_add( irc_t *irc, int protocol, char *user, char *pass );
+account_t *account_get( irc_t *irc, char *id );
+void account_del( irc_t *irc, account_t *acc );
+void account_on( irc_t *irc, account_t *a );
+void account_off( irc_t *irc, account_t *a );
+
+#endif
